## net.sf.saxon.instruct
Class ProcessingInstruction

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.SimpleNodeConstructor
                  net.sf.saxon.instruct.ProcessingInstruction

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

    public class ProcessingInstruction

extends SimpleNodeConstructor

An xsl:processing-instruction element in the stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ProcessingInstruction(Expression name)` Create an xsl:processing-instruction instruction

Method Summary
`void` `display(int level, PrintStream out, Configuration config)` Display this instruction as an expression, for diagnostics
`int` `evaluateNameCode(XPathContext context)`
`int` `getCardinality()` Determine the static cardinality of the expression.
`int` `getDependencies()` Determine which aspects of the context the expression depends on.
`int` `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`ItemType` `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`Expression` `getNameExpression()` Get the expression that defines the processing instruction name
`Iterator` `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`void` `localTypeCheck(StaticContext env, ItemType contextItemType)` Method to perform type-checking specific to the kind of instruction
`TailCall` `processLeavingTail(XPathContext context)` Process this instruction, that is, produce a processing-instruction node in the result sequence.
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`computeCardinality, computeSpecialProperties, createsNewNodes, evaluateItem, expandChildren, getSelect, iterate, optimize, setSelect, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, getColumnNumber, getContainingProcedure, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### ProcessingInstruction

    public ProcessingInstruction(Expression name)

  Create an xsl:processing-instruction instruction

  Parameters:
    `name` - the expression used to compute the name of the generated processing-instruction

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    the string "xsl:processing-instruction"

### getNameExpression

    public Expression getNameExpression()

  Get the expression that defines the processing instruction name

  Returns:
    the expression that defines the processing instruction name

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `Expression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Overrides:
    `getCardinality` in class `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Description copied from class: `Instruction`
  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Overrides:
    `simplify` in class `SimpleNodeConstructor`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### localTypeCheck

    public void localTypeCheck(StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `SimpleNodeConstructor`
  Method to perform type-checking specific to the kind of instruction

  Specified by:
    `localTypeCheck` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Description copied from class: `Expression`
  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Overrides:
    `getDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Description copied from class: `Expression`
  Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.

  Overrides:
    `iterateSubExpressions` in class `SimpleNodeConstructor`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `SimpleNodeConstructor`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction, that is, produce a processing-instruction node in the result sequence.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context of this transformation
  Returns:
    always returns null in this implementation
  Throws:
    `XPathException` - if any non-recoverable dynamic error occurs

### evaluateNameCode

    public int evaluateNameCode(XPathContext context)
                         throws XPathException

  Overrides:
    `evaluateNameCode` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Description copied from class: `SimpleNodeConstructor`
  Display this instruction as an expression, for diagnostics

  Overrides:
    `display` in class `SimpleNodeConstructor`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Copyright (C) Michael H. Kay. All rights reserved.